package lab4;
import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;
import java.sql.*;

public class AccesoSistemaRemotoDB extends UnicastRemoteObject
                                    implements InterfazRemotaLogicaNegocio
{
  public static final int MAX_INTENTOS = 3;
  public static final String nombreServicio = "entrarAlSistema";
  PreparedStatement s;
  Statement st;
  Connection o;

  public AccesoSistemaRemotoDB() throws RemoteException{
  	 try{
       //DriverManager.registerDriver(new sun.jdbc.odbc.JdbcOdbcDriver());
       Class.forName("com.mysql.jdbc.Driver");
       System.out.println("Driver cargado");
       o=DriverManager.getConnection("jdbc:mysql://jipla0.gi.ehu.es/cuentas","ISO","ISO");
       s=o.prepareStatement("select * from cuenta where usuario=? and password=? and numIntentosFallidos<?");
       st=o.createStatement();
      }
      catch (Exception ex){System.out.println("Error: "+ex.toString());}
  }



  public boolean hacerLogin(String a,String b) throws RemoteException {
    try {
      s.setString(1,a);
      s.setString(2,b);
      s.setInt(3,MAX_INTENTOS);
      ResultSet r=s.executeQuery();
      boolean res = r.next();
      if (res) 
        st.executeUpdate("update cuenta set numIntentosFallidos=0 where usuario='"+a+"'");
      else 
        st.executeUpdate("update cuenta set numIntentosFallidos=numIntentosFallidos+1 where usuario='"+a+"'");
      return res;
    }
    catch (Exception ex) {System.out.println("Error: "+ex.toString());
                         return false;}
    }


 public static void main(String[] args) {

	System.setSecurityManager(new RMISecurityManager());

  try {
	AccesoSistemaRemotoDB objetoServidor = new AccesoSistemaRemotoDB();
  System.out.println("objeto lanzado");

  try { java.rmi.registry.LocateRegistry.createRegistry(1099); // RMIREGISTRY jaurtitzearen baliokidea
  } catch (Exception e) {System.out.println(e.toString()+"\nSuponemos que el error es que el servidor rmi ha sido lanzado previamente ");}
	// Registrar servicio remoto
	Naming.rebind(nombreServicio,objetoServidor);
 	// "//Direccion IP:Puerto/nombreServicio"
  // NO FUNCIONA si el nombre del servicio rmiregistry no esta en localhost

  } catch (Exception e)
	 {System.out.println("Error al lanzar el servicio "+e.toString());}

 }
}