package lab4;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.rmi.*;


public class LanzadorRemotoFrame extends JFrame {
  JPanel jPanel1 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField jTextField1 = new JTextField();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  PresentacionRemota a = new PresentacionRemota();
  JTextArea jTextArea1 = new JTextArea();

  public static final String nombreServicio = "entrarAlSistema";

  public LanzadorRemotoFrame() {
    super();
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public static void main(String[] args) {

	 if (System.getSecurityManager() == null) {
         System.setSecurityManager(new SecurityManager());
     }
	  
	  LanzadorRemotoFrame frame = new LanzadorRemotoFrame();
	  frame.setVisible(true);
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(null);
    this.setSize(new Dimension(400, 300));
    jPanel1.setLayout(null);
    jPanel1.setBounds(new Rectangle(0, 0, 392, 273));
    jLabel1.setText("Nombre del host con la lgica de negocio:puerto:");
    jLabel1.setBounds(new Rectangle(52, 50, 279, 17));
    jTextField1.setText("localhost");
    jTextField1.setBounds(new Rectangle(52, 72, 268, 24));
    jButton1.setText("Lanzar presentacin");
    jButton1.setBounds(new Rectangle(93, 116, 194, 34));
    jButton1.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });
    jButton2.setText("Asignar lgica de negocio");
    jButton2.setBounds(new Rectangle(94, 162, 194, 32));
    jTextArea1.setBounds(new Rectangle(46, 210, 308, 57));
    jButton2.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton2_actionPerformed(e);
      }
    });
    this.setTitle("Para lanzar presentacin y asignar la lgica de negocio");
    this.getContentPane().add(jPanel1, null);
    jPanel1.add(jLabel1, null);
    jPanel1.add(jTextField1, null);
    jPanel1.add(jButton1, null);
    jPanel1.add(jButton2, null);
    jPanel1.add(jTextArea1, null);
  }

  void jButton1_actionPerformed(ActionEvent e) {
    a.setVisible(true);
  }

  void jButton2_actionPerformed(ActionEvent e) {
   try{
    System.setSecurityManager(new RMISecurityManager());
    InterfazRemotaLogicaNegocio objetoRemoto;

   String host = jTextField1.getText();
   String nombreServ = "rmi://"+host+"/"+nombreServicio;
   // 	"rmi://Direccin ip:puerto/nombreServicio"

    objetoRemoto = (InterfazRemotaLogicaNegocio)Naming.lookup(nombreServ);
    a.asignarLogicaNegocio(objetoRemoto);
    jTextArea1.setText("Lgica de negocio asignada\n");
   }
   catch (Exception ex) {jTextArea1.setText("Error al asignar la lgica de negocio\n");
                         jTextArea1.append(ex.toString());}
  }

}


